/*
   IPFinder 2.1: Trova tutti gli ip di un pc
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "resource.h"
#include <stdio.h>
#include <winsock2.h>
#include <ws2tcpip.h>

#define BUF 1000


int httpMSG(char* ch){
char msg[4];
msg[0]=ch[9];
msg[1]=ch[10];
msg[2]=ch[11];
msg[3]='\0';
return atoi(msg);
}

void Decode(char* ch){
char ch2[BUF];
char* d1=strstr(ch,"<TITLE>");
char* d2=strstr(d1+7,"</TITLE>");

strncpy(ch2,d1+7,(d2-d1-7));
ch2[(d2-d1-7)]='\0';
strcpy(ch,ch2);

}

void dnsquery(char *name)
{   
	struct hostent *phostent;
    
    if(NULL!=(phostent = gethostbyname(name)))
		
    strcpy(name,inet_ntoa( *( (struct in_addr*)*(phostent->h_addr_list)  ) ));
}

int ifindIP(char *ip)
{
struct sockaddr_in Serv;
char ch[BUF],cmd[BUF],ch2[BUF];
int s;

int fd = socket(AF_INET, SOCK_STREAM, 0);
  Serv.sin_family	 =	AF_INET;
  strcpy(ch,"WhatIsMyIP.com");
  strcpy(ch2,ch);
 dnsquery(ch);
  Serv.sin_addr.s_addr  =	inet_addr(ch);
  Serv.sin_port		 =	htons(80);
 s=connect(fd, (struct sockaddr*) &Serv, sizeof(Serv));
 if (s==-1) return s;
 sprintf(cmd,"GET / HTTP/1.0\r\nhost:%s\r\n\r\n",ch2);
 send(fd,cmd,strlen(cmd),0);

 memset(ip,'\0',sizeof(ch));
s=recv(fd,ch,BUF,0);
if (s==-1) return s;
 ch[s-1]='\0';
s=httpMSG(ch);
if (s!=200) return s;

 Decode(ch);

 strcpy(ip,ch);

closesocket(fd);
return 0;}


BOOL CALLBACK AboutDlgProc4(HWND hwndDlg,  UINT uMsg, WPARAM wParam, LPARAM lParam)
{static char IP[20],IP2[20],IP3[20],IP4[20],IP5[20],IPC[20];
 static SOCKET sd;   
 static sockaddr_in* pAddress;
 static int i,nNumInterfaces,n ;
 static unsigned long nBytesReturned;
 static char msg[1000];
if(uMsg==WM_CLOSE) { 
EndDialog(hwndDlg, 0);  
return TRUE;    }

if(uMsg==WM_COMMAND) { 
  switch (LOWORD (wParam))
	{ 
      case IDC_FIND2:
           n=ifindIP(msg);
		  if (0!=n)
		  sprintf(msg,"collegamento ad internet non trovato\r\n errore %d",n);
		   
       SetDlgItemText(hwndDlg,IDC_EDIT1,msg);
MessageBeep(MB_ICONASTERISK);

	  return 0;


	case IDC_FIND:
n=0;
    memset(IP,'\0',sizeof(IP));
    memset(IP2,'\0',sizeof(IP2));
    memset(IP3,'\0',sizeof(IP3));
    memset(IP4,'\0',sizeof(IP4));
	memset(IP5,'\0',sizeof(IP5));
	memset(IPC,'\0',sizeof(IPC));
        sd = WSASocket(AF_INET, SOCK_DGRAM, 0, 0, 0, 0);

    INTERFACE_INFO InterfaceList[20];
    
WSAIoctl(sd, SIO_GET_INTERFACE_LIST, 0, 0, &InterfaceList,
            sizeof(InterfaceList), &nBytesReturned, 0, 0);
 nNumInterfaces = nBytesReturned / sizeof(INTERFACE_INFO);
for (i = 0; i < nNumInterfaces; ++i) {

        pAddress = (sockaddr_in*)&(InterfaceList[i].iiAddress);
        strcpy(IPC,inet_ntoa(pAddress->sin_addr));
		if ((0!=strcmp(IPC,"0.0.0.0"))&&
            (0!=strcmp(IPC,"127.0.0.1")))
		{n++;

		if (IP[0]=='\0') strcpy(IP,inet_ntoa(pAddress->sin_addr));
		else if (IP2[0]=='\0') strcpy(IP2,inet_ntoa(pAddress->sin_addr));
		else if (IP3[0]=='\0') strcpy(IP3,inet_ntoa(pAddress->sin_addr));
		else if (IP4[0]=='\0') strcpy(IP4,inet_ntoa(pAddress->sin_addr));
		else if (IP5[0]=='\0') strcpy(IP5,inet_ntoa(pAddress->sin_addr));
		}
}

if (n==0) sprintf(msg,"127.0.0.1");
else sprintf(msg,"%s\r\n%s\r\n%s\r\n%s",IP,IP2,IP3,IP4,IP5);
SetDlgItemText(hwndDlg,IDC_EDIT1,msg);

MessageBeep(MB_ICONASTERISK);

		return 0;}

return TRUE;    }

return FALSE; }
      

int WINAPI WinMain(HINSTANCE hInstance,
HINSTANCE hPrevInstance,
LPSTR     lpCmdLine,
int       nCmdShow)
   { 
    WSADATA WinsockData;
   
	int ret=WSAStartup(MAKEWORD(2,2), &WinsockData);	



DialogBox(hInstance,(LPCTSTR)IDD_DIALOG1, NULL, (DLGPROC)AboutDlgProc4);

 WSACleanup();
 
 return 0;}


